/////////////////////////////////////////////////////////////////////////////
// template.idc
/////////////////////////////////////////////////////////////////////////////
#include <idc.idc>

static main() {
  auto ea, fn, fp, flags, sline, i, j, k, l;

	// Output To File
	fn = AskFile(1, "*.lst", "Output File Name?");  // Get *.lst File Name
	fp = fopen(fn, "w");  // Open File for Output

	if(!fp) {
		Warning("Error opening output file!\n");  // Error Opening File
		fclose(fp);
		return;
	}
	
	fprintf(fp, "========================================================================================\n");
	
	i = 0;
	
	for(ea = MinEA(); ea != BADADDR && i++ < 100000; ea = NextNotTail(ea)) {
		Jump(ea);
		
		flags = GetFlags(ea);
		
		fprintf(fp, "%s\n", GetCurrentLine());  // Get disassembly line
			
		fprintf(fp, "----------------------------------------------------------------------------------------\n");

		l = 0;
		
		if(flags & FF_LINE) {
			for (k = 998; k >= 0; k--) if (LineA(ea, k) != "") break;  // Find Last Line  // LineA() bug > 1000t
			
			if((sline =  LineA(ea, 0)) != "") {
				fprintf(fp, "%s\n", "FF_LINE - LineA:");
				fprintf(fp, "\t%s\n", sline);
				l = 1;
			}
			
			for(j = 1; j <= k; j++) fprintf(fp, "\t%s\n", LineA(ea, j));  // Get All Lines
		}
			
		if(l == 1) fprintf(fp, "----------------------------------------------------------------------------------------\n");
			
		l = 0;
		
		if(flags & FF_LINE) {
			for (k = 998; k >= 0; k--) if (LineB(ea,k) != "") break;  // Find Last Line
			
			if((sline =  LineB(ea, 0)) != "") {
				fprintf(fp, "%s\n", "FF_LINE - LineB:");
				fprintf(fp, "\t%s\n", sline);
			}
			
			for(j = 1; j <= k; j++) fprintf(fp, "\t%s\n", LineB(ea, j));  // Get All Lines
		}
			
		if(l == 1) fprintf(fp, "----------------------------------------------------------------------------------------\n");
		
		if(flags & FF_CODE) fprintf(fp, "FF_CODE - GetDisasm(ea) : %s\n", GetDisasm(ea));
		if(flags & FF_DATA) fprintf(fp, "FF_DATA - GetDisasm(ea) : %s\n", GetDisasm(ea));
		
		if(flags & FF_COMM) {
			if((sline = Comment(ea)) != "") fprintf(fp, "FF_COMM - Comment(ea) : %s\n", sline);
			if((sline = RptCmt(ea)) != "") fprintf(fp, "FF_COMM - RptCmt(ea) : %s\n", sline);
		}
		
		if(flags & FF_NAME) {
			if((sline = Name(ea)) != "") fprintf(fp, "FF_NAME - Name(ea) : %s\n", Name(ea));  // User-defined has name
			if((sline = NameEx(BADADDR, ea)) != "") fprintf(fp, "FF_NAME - NameEx(BADADDR, ea) : %s\n", sline);  // Get visible name of the byte 
			if((sline = GetTrueNameEx(BADADDR, ea)) != "") fprintf(fp, "FF_NAME - GetTrueNameEx(BADADDR, ea) : %s\n", GetTrueNameEx(BADADDR, ea));  // Get true name of the byte 
		}
		
		if(flags & FF_FUNC) fprintf(fp, "FF_FUNC - GetFunctionName(ea): %s\n", GetFunctionName(ea));  // Function start
		
		if(flags & FF_LABL) fprintf(fp, "FF_LABL : Dummy has name\n");
		if(flags & FF_ANYNAME) fprintf(fp, "FF_ANYNAME = FF_LABL|FF_NAME)\n");
		if(flags & FF_IVL) fprintf(fp, "FF_IVL : Byte has value\n");
		if(flags & FF_TAIL) fprintf(fp, "FF_TAIL : Tail\n");
		if(flags & FF_UNK) fprintf(fp, "FF_UNK : Unknown\n");
		if(flags & FF_REF) fprintf(fp, "FF_REF : References\n");		
		if(flags & FF_FLOW) fprintf(fp, "FF_FLOW : Exec flow from prev instruction\n");
		if(flags & FF_VAR) fprintf(fp, "FF_VAR : Byte is variable\n");
		if(flags & FF_0VOID) fprintf(fp, "FF_0VOID :Void (unknown) 1\n");
		if(flags & FF_0NUMH) fprintf(fp, "FF_0NUMH : Hexadecimal number 1\n");
		if(flags & FF_0NUMD) fprintf(fp, "FF_0NUMD : Decimal number 1\n");
		if(flags & FF_0CHAR) fprintf(fp, "FF_0CHAR : Char ('x') 1\n");
		if(flags & FF_0SEG) fprintf(fp, "FF_0SEG : Segment 1\n");
		if(flags & FF_0OFF) fprintf(fp, "FF_0OFF : Offset 1\n");
		if(flags & FF_0NUMB) fprintf(fp, "FF_0NUMB : Binary number 1\n");
		if(flags & FF_0NUMO) fprintf(fp, "FF_0NUMO : Octal number 1\n");
		if(flags & FF_0ENUM) fprintf(fp, "FF_0ENUM : Enumeration 1\n");
		if(flags & FF_0FOP) fprintf(fp, "FF_0FOP : Forced operand 1\n");
		if(flags & FF_0STRO) fprintf(fp, "FF_0STRO : Struct offset 1\n");
		if(flags & FF_0STK) fprintf(fp, "FF_0STK : Stack variable 1\n");
		if(flags & FF_0FLT) fprintf(fp, "FF_0FLT : Floating point number 1\n");
		if(flags & FF_0CUST) fprintf(fp, "FF_0CUST : Custom format type 1\n");
		if(flags & FF_1VOID) fprintf(fp, "FF_1VOID : Void (unknown) 2\n");
		if(flags & FF_1NUMH) fprintf(fp, "FF_1NUMH : Hexadecimal number 2\n");
		if(flags & FF_1NUMD) fprintf(fp, "FF_1NUMD : Decimal number 2\n");
		if(flags & FF_1CHAR) fprintf(fp, "FF_1CHAR : Char ('x') 2\n");
		if(flags & FF_1SEG) fprintf(fp, "FF_1SEG : Segment 2\n");
		if(flags & FF_1OFF) fprintf(fp, "FF_1OFF : Offset 2\n");
		if(flags & FF_1NUMB) fprintf(fp, "FF_1NUMB : Binary number 2\n");
		if(flags & FF_1NUMO) fprintf(fp, "FF_1NUMO : Octal number 2\n");
		if(flags & FF_1ENUM) fprintf(fp, "FF_1ENUM : Enumeration 2\n");
		if(flags & FF_1FOP) fprintf(fp, "FF_1FOP : Forced operand 2v");
		if(flags & FF_1STRO) fprintf(fp, "FF_1STRO : Struct offset 2\n");
		if(flags & FF_1STK) fprintf(fp, "FF_1STK : Stack variable 2\n");
		if(flags & FF_1FLT) fprintf(fp, "FF_1FLT : Floating point number 2\n");
		if(flags & FF_1CUST) fprintf(fp, "FF_1CUST : Custom format type 2\n");
		if(flags & FF_BYTE) fprintf(fp, "FF_BYTE : Byte\n");
		if(flags & FF_WORD) fprintf(fp, "FF_WORD : Word\n");
		if(flags & FF_DWRD) fprintf(fp, "FF_DWRD : Dword\n");
		if(flags & FF_QWRD) fprintf(fp, "FF_QWRD : Qword\n");
		if(flags & FF_TBYT) fprintf(fp, "FF_TBYT : Tbyte\n");
		if(flags & FF_ASCI) fprintf(fp, "FF_ASCI : ASCII\n");
		if(flags & FF_STRU) fprintf(fp, "FF_STRU : Struct\n");
		if(flags & FF_OWRD) fprintf(fp, "FF_OWRD : Octaword (16 bytes)\n");
		if(flags & FF_FLOAT) fprintf(fp, "FF_FLOAT : Float\n");
		if(flags & FF_DOUBLE) fprintf(fp, "FF_DOUBLE : Double\n");
		if(flags & FF_PACKREAL) fprintf(fp, "FF_PACKREAL : Packed decimal real\n");		
		if(flags & FF_ALIGN) fprintf(fp, "FF_ALIGN : Alignment directive\n");		
		if(flags & FF_3BYTE) fprintf(fp, "FF_3BYTE : 3-byte data\n");
		if(flags & FF_CUSTOM) fprintf(fp, "FF_CUSTOM : Custom data type\n");		
		if(flags & FF_IMMD) fprintf(fp, "FF_IMMD : Immediate has value\n");
		if(flags & FF_JUMP) fprintf(fp, "FF_JUMP : Jump has table\n");

		// fprintf(fp, "----------------------------------------------------------------------------------------\n");

		// if((sline = GetMnem(ea)) != "") fprintf(fp, "Get instruction name - GetMnem(ea) : %s\n", sline);  // Get instruction name
		// if((sline = GetOpnd(ea, 0)) != "") fprintf(fp, "GetOpnd 1 - GetOpnd(ea, 0): %s\n", sline);  // Get instruction operand 1
		// if((sline = GetOpnd(ea, 1)) != "") fprintf(fp, "GetOpnd 2 - GetOpnd(ea, 1): %s\n", sline);  // Get instruction operand 2
		// if((sline = AltOp(ea, 0)) != "") fprintf(fp, "AltOp 1 - AltOp(ea, 0): %s\n", sline);  // Get manually entered operand 1
		// if((sline = AltOp(ea, 1)) != "") fprintf(fp, "AltOp 2 - AltOp(ea, 1): %s\n", sline);  // Get manually entered operand 2		
		
		if((sline = GetFunctionCmt(ea, 0)) != "") fprintf(fp, "GetFunctionCmt 1 - GetFunctionCmt(ea, 0): %s\n", sline);  // Get Comment 1
		if((sline = GetFunctionCmt(ea, 1)) != "") fprintf(fp, "GetFunctionCmt 2 - GetFunctionCmt(ea, 1): %s\n", sline);  // Get Comment 2
		
		fprintf(fp, "========================================================================================\n");
	}

	fclose(fp);
}
